/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ProjectionandThalamicFibers;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_RespiratoryStatus;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_ProjectionandThalamicFibers;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumAnatomicSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;


/**
 * This class represents ProjectionandThalamicFibers CID7702
 */
public class ProjectionandThalamicFibers_CID7702 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new ProjectionandThalamicFibers_CID7702 Template 
	 */
	public ProjectionandThalamicFibers_CID7702()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumProjectionandThalamicFibers Object of EnumCM_ProjectionandThalamicFibers represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_ProjectionandThalamicFibers enumProjectionandThalamicFibers)
	{
		switch(enumProjectionandThalamicFibers)  
		{
		case CORTICOBULBAR_TRACT: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.CORTICOBULBAR_TRACT_1319.getValue(); break;
		case CORTICOSPINAL_TRACT: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.CORTICOSPINAL_TRACT_1320.getValue(); break;
		case INTERNAL_CAPSULE: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.INTERNAL_CAPSULE_T_A3700.getValue(); break;
		case EXTERNAL_CAPSULE: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.EXTERNAL_CAPSULE_T_A3800.getValue(); break;
		case AUDITORY_ACOUSTIC_RADIATION_GENICULOTEMPORAL_TRACT: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.AUDITORY_ACOUSTIC_RADIATION_GENICULOTEMPORAL_TRACT_T_D0829.getValue(); break;
		case OPTIC_RADIATION_GENICULO_CALCARINE_TRACT_GENICULOSTRIATE_PATHWAY: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.OPTIC_RADIATION_GENICULO_CALCARINE_TRACT_GENICULOSTRIATE_PATHWAY_T_A2880.getValue(); break;
		case INFERIOR_OPTIC_RADIATION_MEYERS_LOOP: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.INFERIOR_OPTIC_RADIATION_MEYERS_LOOP_1466.getValue(); break;
		case SUPERIOR_OPTIC_RADIATION_BAUMS_LOOP: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.SUPERIOR_OPTIC_RADIATION_BAUMS_LOOP_3473.getValue(); break;
		case ANTERIOR_THALAMIC_RADIATION: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.ANTERIOR_THALAMIC_RADIATION_1726.getValue(); break;
		case SUPERIOR_THALAMIC_RADIATION: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.SUPERIOR_THALAMIC_RADIATION_2081.getValue(); break;
		case INFERIOR_THALAMIC_RADIATION: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.INFERIOR_THALAMIC_RADIATION_2082.getValue(); break;
		case POSTERIOR_THALAMIC_RADIATION: this.strCodeValue =EnumCV_ProjectionandThalamicFibers.POSTERIOR_THALAMIC_RADIATION_2083.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumProjectionandThalamicFibers Object of EnumCM_ProjectionandThalamicFibers represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_ProjectionandThalamicFibers enumProjectionandThalamicFibers)
	{
		switch(enumProjectionandThalamicFibers)
		{
		case INTERNAL_CAPSULE : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.INTERNAL_CAPSULE.getSNOMEDCTID(); break;
		case EXTERNAL_CAPSULE : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.EXTERNAL_CAPSULE.getSNOMEDCTID(); break;
		case AUDITORY_ACOUSTIC_RADIATION_GENICULOTEMPORAL_TRACT : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.AUDITORY_ACOUSTIC_RADIATION_GENICULOTEMPORAL_TRACT.getSNOMEDCTID(); break;
		case OPTIC_RADIATION_GENICULO_CALCARINE_TRACT_GENICULOSTRIATE_PATHWAY : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.OPTIC_RADIATION_GENICULO_CALCARINE_TRACT_GENICULOSTRIATE_PATHWAY.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for ProjectionandThalamicFibers
	 * @param enumProjectionandThalamicFibers Object of EnumCM_ProjectionandThalamicFibers.
	 */
	public void setProjectionandThalamicFibers(EnumCM_ProjectionandThalamicFibers enumProjectionandThalamicFibers)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumProjectionandThalamicFibers.getValue();
		if(strCodeMeaning.equalsIgnoreCase(EnumCM_ProjectionandThalamicFibers.INTERNAL_CAPSULE.getValue())||
				strCodeMeaning.equalsIgnoreCase(EnumCM_ProjectionandThalamicFibers.EXTERNAL_CAPSULE.getValue())||
				strCodeMeaning.equalsIgnoreCase(EnumCM_ProjectionandThalamicFibers.AUDITORY_ACOUSTIC_RADIATION_GENICULOTEMPORAL_TRACT.getValue())||
				strCodeMeaning.equalsIgnoreCase(EnumCM_ProjectionandThalamicFibers.OPTIC_RADIATION_GENICULO_CALCARINE_TRACT_GENICULOSTRIATE_PATHWAY.getValue()))
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		else
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.NEU.getValue();		
		/**
		 * set code Value
		 */
		setCodeValue(enumProjectionandThalamicFibers);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumProjectionandThalamicFibers);
	}
}
